diff --git a/client/suse/compat-suse.c b/client/suse/compat-suse.c
index 85b01df12..d2fdd9a49 100644
--- a/client/suse/compat-suse.c
+++ b/client/suse/compat-suse.c
@@ -3063,77 +3274,6 @@ try_bridge(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		}
 	}
 
-	if ((value = ni_sysconfig_get_value(sc, "BRIDGE_PORTS")) != NULL) {
-		char *portnames = NULL, *name_pos = NULL, *name = NULL;
-
-		ni_string_dup(&portnames, value);
-		for (name = strtok_r(portnames, " \t", &name_pos);
-		     name != NULL;
-		     name = strtok_r(NULL, " \t", &name_pos)) {
-
-			if (!ni_netdev_name_is_valid(name)) {
-				ni_error("ifcfg-%s: BRIDGE_PORTS='%s' "
-					 "rejecting suspect port name '%s'",
-					 dev->name, value, name);
-				free(portnames);
-				return -1;
-			}
-
-			ni_bridge_port_new(bridge, name, 0);
-		}
-		ni_string_free(&portnames);
-	}
-
-	if ((value = ni_sysconfig_get_value(sc, "BRIDGE_PORTPRIORITIES")) != NULL) {
-		char *portprios = NULL, *prio_pos = NULL, *prio = NULL;
-		unsigned int tmp, i = 0;
-
-		ni_string_dup(&portprios, value);
-		for (prio = strtok_r(portprios, " \t", &prio_pos);
-		     prio != NULL && i < bridge->ports.count;
-		     prio = strtok_r(NULL, " \t", &prio_pos), ++i) {
-			ni_bridge_port_t *port = bridge->ports.data[i];
-
-			if (!strcmp("-", prio))
-				continue;
-
-			if (ni_parse_uint(prio, &tmp, 0) < 0) {
-				ni_error("ifcfg-%s: BRIDGE_PORTPRIORITIES='%s' "
-					 "unable to parse port '%s' priority '%s'",
-					 dev->name, value, port->ifname, prio);
-				free(portprios);
-				return -1;
-			}
-			port->priority = tmp;
-		}
-		ni_string_free(&portprios);
-	}
-
-	if ((value = ni_sysconfig_get_value(sc, "BRIDGE_PATHCOSTS")) != NULL) {
-		char *portcosts = NULL, *cost_pos = NULL, *cost = NULL;
-		unsigned int tmp, i = 0;
-
-		ni_string_dup(&portcosts, value);
-		for (cost = strtok_r(portcosts, " \t", &cost_pos);
-		     cost != NULL && i < bridge->ports.count;
-		     cost = strtok_r(NULL, " \t", &cost_pos), ++i) {
-			ni_bridge_port_t *port = bridge->ports.data[i++];
-
-			if (!strcmp("-", cost))
-				continue;
-
-			if (ni_parse_uint(cost, &tmp, 0) < 0) {
-				ni_error("ifcfg-%s: BRIDGE_PATHCOSTS='%s' "
-					 "unable to parse port '%s' costs '%s'",
-					 dev->name, value, port->ifname, cost);
-				free(portcosts);
-				return -1;
-			}
-			port->path_cost = tmp;
-		}
-		ni_string_free(&portcosts);
-	}
-
 	if ((value = ni_bridge_validate(bridge)) != NULL) {
 		ni_error("ifcfg-%s: bridge validation: %s", dev->name, value);
 		return -1;
@@ -3147,6 +3287,8 @@ try_bridge(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		}
 	}
 
+	try_add_bridge_ports(ifcfgs, ifcfg);
+
 	return 0;
 }
 
@@ -3154,9 +3296,10 @@ try_bridge(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
  * VLAN interfaces are recognized by their name (vlan<N>)
  */
 static int
-try_vlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_vlan(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_vlan_t *vlan;
 	const char *etherdev = NULL;
 	const char *vlanprot = NULL;
@@ -3165,7 +3308,8 @@ try_vlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	unsigned int tag = 0;
 	size_t len;
 
-	if ((etherdev = ni_sysconfig_get_value(sc, "ETHERDEVICE")) == NULL)
+	etherdev = ni_sysconfig_get_value(sc, "ETHERDEVICE");
+	if (ni_string_empty(etherdev))
 		return 1;
 
 	if (dev->link.type != NI_IFTYPE_UNKNOWN) {
@@ -3175,11 +3319,9 @@ try_vlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	}
 
 	dev->link.type = NI_IFTYPE_VLAN;
-	vlan = ni_netdev_get_vlan(dev);
-
-	if (!strcmp(dev->name, etherdev)) {
-		ni_error("ifcfg-%s: ETHERDEVICE=\"%s\" self-reference",
-			dev->name, etherdev);
+	if (!(vlan = ni_netdev_get_vlan(dev))) {
+		ni_error("ifcfg-%s: unable to allocate ethernet vlan structure",
+				dev->name);
 		return -1;
 	}
 
@@ -3227,6 +3369,9 @@ try_vlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		vlan->protocol = protocol;
 	}
 
+	if (!ni_suse_ifcfg_add_lower(ifcfgs, ifcfg, etherdev, "vlan ETHERDEVICE"))
+		return -1;
+
 	ni_string_dup(&dev->link.lowerdev.name, etherdev);
 	vlan->tag = tag;
 
@@ -3242,9 +3387,10 @@ try_vlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 }
 
 static int
-try_vxlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_vxlan(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_vxlan_t *vxlan;
 	ni_bool_t enabled;
 	unsigned int val;
@@ -3271,11 +3417,9 @@ try_vxlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		}
 	}
 	if ((str = ni_sysconfig_get_value(sc, "VXLAN_DEVICE"))) {
-		if (!ni_netdev_name_is_valid(str) || ni_string_eq(str, dev->name)) {
-			ni_error("ifcfg-%s: Invalid name in VXLAN_DEVICE=\"%s\"",
-					dev->name, ni_print_suspect(str, 15));
+		if (!ni_suse_ifcfg_add_lower(ifcfgs, ifcfg, str, "VXLAN_DEVICE"))
 			return -1;
-		}
+
 		ni_string_dup(&dev->link.lowerdev.name, str);
 	}
 
@@ -3469,9 +3613,10 @@ try_vxlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
  * differ from the macvlan/tap device being created.
  */
 static int
-try_macvlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_macvlan(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_macvlan_t *macvlan = NULL;
 	const char *macvlan_dev = NULL;
 	unsigned int macvlan_iftype = NI_IFTYPE_UNKNOWN;
@@ -3512,11 +3657,8 @@ try_macvlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		return -1;
 	}
 
-	if (!strcmp(dev->name, macvlan_dev)) {
-		ni_error("ifcfg-%s: %s=\"%s\" self-reference",
-			dev->name, syscfg_dev_key, macvlan_dev);
+	if (!ni_suse_ifcfg_add_lower(ifcfgs, ifcfg, macvlan_dev, syscfg_dev_key))
 		return -1;
-	}
 
 	macvlan->mode = NI_MACVLAN_MODE_VEPA;
         if ((macvlan_mode = ni_sysconfig_get_value(sc, syscfg_mode_key)) != NULL) {
@@ -3569,9 +3711,10 @@ try_macvlan(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
  * itself.
  */
 static int
-try_dummy(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_dummy(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *iftype = NULL;
 	const char *lladdr = NULL;
 	const char *bootproto = NULL;
@@ -4361,9 +4504,10 @@ eap_failure:
 }
 
 static int
-try_wireless(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_wireless(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_string_array_t vnames = NI_STRING_ARRAY_INIT;
 	ni_bool_t enabled = FALSE;
 	const char *value;
@@ -4415,20 +4559,17 @@ __ni_suse_read_provider(const char *sibling, const char *provider)
 }
 
 static int
-try_pppoe(const ni_sysconfig_t *sc, const ni_sysconfig_t *psc, const char *name, ni_ppp_mode_pppoe_t *pppoe)
+try_pppoe(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		ni_ppp_mode_pppoe_t *pppoe)
 {
+	const ni_sysconfig_t *sc = ifcfg->config;
 	const char *value;
 
-	if (!sc || !psc || !pppoe || ni_string_empty(name))
-		return -1;
-
 	value = ni_sysconfig_get_value(sc, "DEVICE");
-	if (ni_string_empty(value) || !ni_netdev_name_is_valid(value) ||
-	    !ni_netdev_ref_set_ifname(&pppoe->device, value)) {
-		ni_error("ifcfg-%s: PPPoE config without valid ethernet device name: '%s'", name, value ? value : "");
+	if (!ni_suse_ifcfg_add_lower(ifcfgs, ifcfg, value, "PPPoE ethernet device"))
 		return -1;
-	}
 
+	ni_netdev_ref_set_ifname(&pppoe->device, value);
 	return 0;
 }
 
@@ -4436,9 +4577,10 @@ try_pppoe(const ni_sysconfig_t *sc, const ni_sysconfig_t *psc, const char *name,
  * Handle all sorts of PPP
  */
 static int
-try_ppp(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_ppp(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_sysconfig_t *psc = NULL;
 	const char *value;
 	ni_bool_t bval;
@@ -4586,7 +4728,7 @@ try_ppp(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	ret = 0;
 	switch (ppp->mode.type) {
 	case NI_PPP_MODE_PPPOE:
-		ret = try_pppoe(sc, psc, dev->name, &ppp->mode.pppoe);
+		ret = try_pppoe(ifcfgs, ifcfg, &ppp->mode.pppoe);
 		break;
 	case NI_PPP_MODE_PPPOATM:
 		/* PPPoATM support is not implemented */
@@ -4607,8 +4749,7 @@ try_ppp(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	}
 
 done:
-	if (psc)
-		ni_sysconfig_destroy(psc);
+	ni_sysconfig_free(psc);
 	return ret;
 }
 
@@ -4616,9 +4757,10 @@ done:
  * Handle Tunnel interfaces
  */
 static int
-__try_tunnel_tuntap(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_tunnel_tuntap(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *value;
 	ni_tuntap_t *tuntap;
 
@@ -4662,24 +4804,18 @@ __try_tunnel_tuntap(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 }
 
 static int
-__try_tunnel_generic(const char *ifname, unsigned short arp_type,
-		ni_linkinfo_t *link, ni_tunnel_t *tunnel,
-		const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_tunnel_generic(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg,
+		const char *ifname, unsigned short arp_type,
+		ni_linkinfo_t *link, ni_tunnel_t *tunnel)
 {
+	const ni_sysconfig_t *sc = ifcfg->config;
 	const char *value = NULL;
 	unsigned int ui_value;
 
 	if ((value = ni_sysconfig_get_value(sc, "TUNNEL_DEVICE"))) {
-		if (!ni_netdev_name_is_valid(value)) {
-			ni_error("ifcfg-%s: TUNNEL_DEVICE=\"%s\" suspect interface name",
-					ifname, value);
+		if (!ni_suse_ifcfg_add_lower(ifcfgs, ifcfg, value, "TUNNEL_DEVICE"))
 			return -1;
-		}
-		if (ni_string_eq(value, ifname)) {
-			ni_error("ifcfg-%s: TUNNEL_DEVICE=\"%s\" invalid self-reference",
-					ifname, value);
-			return -1;
-		}
+
 		ni_string_dup(&link->lowerdev.name, value);
 	}
 
@@ -4737,9 +4873,9 @@ __try_tunnel_generic(const char *ifname, unsigned short arp_type,
 }
 
 static int
-__try_tunnel_ipip(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_tunnel_ipip(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_ipip_t *ipip = NULL;
 	int rv = 0;
 
@@ -4747,17 +4883,18 @@ __try_tunnel_ipip(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		return -1;
 
 	/* Populate generic tunneling data from config. */
-	rv = __try_tunnel_generic(dev->name, ARPHRD_TUNNEL, &dev->link,
-				&ipip->tunnel, sc, compat);
+	rv = try_tunnel_generic(ifcfgs, ifcfg, dev->name, ARPHRD_TUNNEL,
+				&dev->link, &ipip->tunnel);
 
 	return rv;
 }
 
 static int
-__try_tunnel_gre(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_tunnel_gre(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
 	ni_string_array_t flags = NI_STRING_ARRAY_INIT;
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_gre_t *gre = NULL;
 	ni_sockaddr_t addr;
 	const char *value;
@@ -4768,8 +4905,8 @@ __try_tunnel_gre(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		return -1;
 
 	/* Populate generic tunneling data from config. */
-	rv = __try_tunnel_generic(dev->name, ARPHRD_IPGRE, &dev->link,
-				&gre->tunnel, sc, compat);
+	rv = try_tunnel_generic(ifcfgs, ifcfg, dev->name, ARPHRD_IPGRE,
+				&dev->link, &gre->tunnel);
 
 	if ((value = ni_sysconfig_get_value(sc, "TUNNEL_GRE_FLAGS"))) {
 		ni_string_split(&flags, value, " \t", 0);
@@ -4860,9 +4997,10 @@ __try_tunnel_gre(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 }
 
 static int
-__try_tunnel_sit(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_tunnel_sit(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	ni_sit_t *sit = NULL;
 	const char *value = NULL;
 	int rv = 0;
@@ -4871,8 +5009,8 @@ __try_tunnel_sit(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		return -1;
 
 	/* Populate generic tunneling data from config. */
-	rv = __try_tunnel_generic(dev->name, ARPHRD_SIT, &dev->link,
-				&sit->tunnel, sc, compat);
+	rv = try_tunnel_generic(ifcfgs, ifcfg, dev->name, ARPHRD_SIT,
+				&dev->link, &sit->tunnel);
 
 	if ((value = ni_sysconfig_get_value(sc, "SIT_ISATAP"))) {
 		if (ni_parse_boolean(value, &sit->isatap) < 0) {
@@ -4886,11 +5024,12 @@ __try_tunnel_sit(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 }
 
 static int
-try_tunnel(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+try_tunnel(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
-	ni_netdev_t *dev = compat->dev;
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_netdev_t *dev = ifcfg->compat->dev;
 	const char *value;
-	static const ni_intmap_t __tunnel_types[] = {
+	static const ni_intmap_t tunnel_types[] = {
 		{ "tun",	NI_IFTYPE_TUN		},
 		{ "tap",	NI_IFTYPE_TAP		},
 		{ "sit",	NI_IFTYPE_SIT		},
@@ -4904,7 +5043,7 @@ try_tunnel(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	if ((value = ni_sysconfig_get_value(sc, "TUNNEL")) == NULL)
 		return 1;
 
-	for (map = __tunnel_types; map->name; ++map) {
+	for (map = tunnel_types; map->name; ++map) {
 		if (!strcmp(map->name, value))
 			break;
 	}
@@ -4924,16 +5063,16 @@ try_tunnel(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	switch (dev->link.type) {
 	case NI_IFTYPE_TUN:
 	case NI_IFTYPE_TAP:
-		return __try_tunnel_tuntap(sc, compat);
+		return try_tunnel_tuntap(ifcfgs, ifcfg);
 
 	case NI_IFTYPE_IPIP:
-		return __try_tunnel_ipip(sc, compat);
+		return try_tunnel_ipip(ifcfgs, ifcfg);
 
 	case NI_IFTYPE_GRE:
-		return __try_tunnel_gre(sc, compat);
+		return try_tunnel_gre(ifcfgs, ifcfg);
 
 	case NI_IFTYPE_SIT:
-		return __try_tunnel_sit(sc, compat);
+		return try_tunnel_sit(ifcfgs, ifcfg);
 
 	default:
 		ni_warn("ifcfg-%s: conversion of %s tunnels not yet supported",
@@ -5760,7 +5899,7 @@ __ni_suse_addrconf_dhcp4(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat, n
 	config = ni_config_dhcp4_find_device(dev->name);
 	if ((merged = ni_sysconfig_merge_defaults(sc, __ni_suse_dhcp_defaults))) {
 		__ni_suse_addrconf_dhcp4_options(merged, compat, config);
-		ni_sysconfig_destroy(merged);
+		ni_sysconfig_free(merged);
 	}
 
 	compat->dhcp4.enabled = TRUE;
@@ -5789,7 +5928,7 @@ __ni_suse_addrconf_dhcp6(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat, n
 	config = ni_config_dhcp6_find_device(dev->name);
 	if ((merged = ni_sysconfig_merge_defaults(sc, __ni_suse_dhcp_defaults))) {
 		__ni_suse_addrconf_dhcp6_options(merged, compat, config);
-		ni_sysconfig_destroy(merged);
+		ni_sysconfig_free(merged);
 	}
 
 	compat->dhcp6.enabled = TRUE;
@@ -5874,7 +6013,7 @@ __ni_suse_addrconf_auto6(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 					dev->name, ni_print_suspect(value, ni_string_len(value)));
 			}
 		}
-		ni_sysconfig_destroy(merged);
+		ni_sysconfig_free(merged);
 	}
 	return TRUE;
 
@@ -5885,8 +6024,10 @@ ignored:
 
 
 static ni_bool_t
-__ni_suse_bootproto(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+ni_suse_ifcfg_parse_bootproto(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_compat_netdev_t *compat = ifcfg->compat;
 	ni_netdev_t *dev = compat->dev;
 	ni_bool_t primary;
 	const char *bootproto;
@@ -5895,7 +6036,21 @@ __ni_suse_bootproto(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	ni_ipv4_devinfo_t *ipv4;
 	ni_ipv6_devinfo_t *ipv6;
 
+	/*
+	 * The L3 setup & boot protocols are disabled on L2 ports already.
+	 */
+	if (ifcfg->l2only)
+		return TRUE;
+
+	/*
+	 * The BOOTPROTO=none disables the L3 (IP) setup & boot protocols.
+	 */
 	bootproto = ni_sysconfig_get_value(sc, "BOOTPROTO");
+	if (ni_string_eq_nocase(bootproto, "none")) {
+		ni_suse_ifcfg_set_l2_only(ifcfg, FALSE);
+		return TRUE;
+	}
+
 	if (ni_string_empty(bootproto) || ni_string_eq(dev->name, "lo")) {
 		if (dev->link.type == NI_IFTYPE_PPP)
 			bootproto = "ppp";
@@ -5904,16 +6059,6 @@ __ni_suse_bootproto(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	}
 
 	ipv4 = ni_netdev_get_ipv4(dev);
-	ipv6 = ni_netdev_get_ipv6(dev);
-
-	if (dev->link.masterdev.name || ni_string_eq_nocase(bootproto, "none")) {
-		if (ipv4)
-			ni_tristate_set(&ipv4->conf.enabled, FALSE);
-		if (ipv6)
-			ni_tristate_set(&ipv6->conf.enabled, FALSE);
-		return TRUE;
-	}
-
 	if (ipv4 && !ni_tristate_is_disabled(ipv4->conf.enabled)) {
 		if (__ni_suse_config_defaults) {
 			if ((value = ni_sysconfig_get_value(__ni_suse_config_defaults,
@@ -5935,17 +6080,13 @@ __ni_suse_bootproto(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 		}
 	}
 
-	if (dev->link.type == NI_IFTYPE_PPP && dev->ppp && !ipv6->conf.enabled)
+	ipv6 = ni_netdev_get_ipv6(dev);
+	if (ipv6 && dev->link.type == NI_IFTYPE_PPP && dev->ppp && !ipv6->conf.enabled)
 		dev->ppp->config.ipv6.enabled = FALSE;
 
 	if (ni_string_eq_nocase(bootproto, "ppp"))
 		return TRUE;
 
-	/* Hmm... ignore this config completely -> ibft firmware */
-	if (ni_string_eq_nocase(bootproto, "ibft")) {
-		return TRUE;
-	}
-
 	if (ni_string_eq_nocase(bootproto, "6to4")) {
 		__ni_suse_addrconf_static(sc, compat);
 		return TRUE;
@@ -6192,9 +6333,11 @@ __ni_suse_qualify_scripts(ni_compat_netdev_t *compat, const char *set, const cha
 	ni_string_array_destroy(&qualified);
 }
 
-static void
-__ni_suse_get_scripts(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+static ni_bool_t
+ni_suse_ifcfg_parse_scripts(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_compat_netdev_t *compat = ifcfg->compat;
 	const char *value;
 
 	value = ni_sysconfig_get_value(sc, "PRE_UP_SCRIPT");
@@ -6216,11 +6359,15 @@ __ni_suse_get_scripts(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 	if (!value && __ni_suse_config_defaults)
 		value = ni_sysconfig_get_value(__ni_suse_config_defaults, "POST_DOWN_SCRIPT");
 	__ni_suse_qualify_scripts(compat, "post-down", value);
+
+	return TRUE;
 }
 
-static void
-ni_suse_ifcfg_get_firewall(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
+static ni_bool_t
+ni_suse_ifcfg_parse_firewall(ni_suse_ifcfg_array_t *ifcfgs, ni_suse_ifcfg_t *ifcfg)
 {
+	const ni_sysconfig_t *sc = ifcfg->config;
+	ni_compat_netdev_t *compat = ifcfg->compat;
 	ni_sysconfig_t *merged;
 	const char *value;
 
@@ -6232,11 +6379,11 @@ ni_suse_ifcfg_get_firewall(const ni_sysconfig_t *sc, ni_compat_netdev_t *compat)
 			if (!ni_string_empty(value))
 				ni_string_dup(&compat->firewall.zone, value);
 		}
-		ni_sysconfig_destroy(merged);
+		ni_sysconfig_free(merged);
 	}
+	return TRUE;
 }
 
-
 /*
  * Read ifsysctl file
  */
